poj 3126 Prime Path

Prime Path

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0
大致题意:

给定两个四位素数a和b,要求把a变到b

变换的过程要保证 每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数    前一步得到的素数  只能有一个位不同,而且每步得到的素数都不能重复。

求从ab最少需要的变换次数。无法变换则输出Impossible

bfs直接水过。。。

具体实现如下:

#define _CRT_SECURE_NO_WARNINGS
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#define INF 0x7ffffff
#define N 10000 + 2
int PrimeTable[N], Queue[N << 1], Drict[N];
int IsPrime(int n)
{
	int i;
	for (i = 2; i*i <= n; i++)
	if (0 == n % i)
		return 0;
	return 1 != n;
}
void Init()
{
	int i;
	memset(PrimeTable, 0, sizeof(PrimeTable));
	for (i = 1000; i <= 10000; i++)
	{
		if (IsPrime(i))
			PrimeTable[i] = 1;
	}
}
void bfs(int start, int end)
{
	int i, j, cur, now, rear = 0, front = 0, flag = 1;;
	if (!PrimeTable[start] || !PrimeTable[end])
		flag = 0;
	char buf[5] = { 0 };
	for (i = 0; flag & 1, i < N; i++)
		Drict[i] = INF;
	Queue[rear++] = start;
	Drict[start] = 0;
	while (front < rear && flag)
	{
		now = Queue[front++];
		if (now == end)
			break;
		for (j = 3; j >= 0; j--)
		{
			sprintf(buf, "%d", now);
			for (i = 0; i <= 9; i++)
			{
				buf[j] = i + '0';
				int nx = atoi(buf);
				if (PrimeTable[nx] && nx < N && INF == Drict[nx])
				{
					cur = nx;
					Drict[cur] = Drict[now] + 1;
					Queue[rear++] = cur;
				}
			}
		}
	}
	if (INF == Drict[end] || !flag)
		printf("Impossible\n");
	else
		printf("%d\n", Drict[end]);
}
void solve()
{
	int n1, n2;
	scanf("%d %d", &n1, &n2);
	bfs(n1, n2);
}
int main()
{
	Init();
	int t;
	scanf("%d", &t);
	while (t--)
		solve();
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值